=== tests/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_LIST_DIR}/../src)
include(tomahawk_add_test.cmake)

tomahawk_add_test(Foo)
