=== thirdparty/CMakeLists.txt ===
ADD_SUBDIRECTORY( qxt )
IF( WITH_BREAKPAD )
    ADD_SUBDIRECTORY( breakpad )
ENDIF()
IF( APPLE )
    ADD_SUBDIRECTORY( SPMediaKeyTap )
ENDIF()
