=== thirdparty/qxt/CMakeLists.txt ===
ADD_SUBDIRECTORY( qxtweb-standalone )
