=== debian/changelog ===
tomahawk (0.7.0+dfsg1-0ubuntu6) utopic; urgency=medium

  * Build-depend on libquazip-dev rather than libquazip0-dev.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 19 Sep 2014 12:30:48 +0100

tomahawk (0.7.0+dfsg1-0ubuntu5) trusty; urgency=medium

  * Fix install files even harder for armhf (add arm specific file)
  * Set WITH_BREAKPAD to OFF for arm variants so maybe arm64 will build

 -- Scott Kitterman <scott@kitterman.com>  Sat, 22 Mar 2014 22:59:27 -0400

tomahawk (0.7.0+dfsg1-0ubuntu4) trusty; urgency=medium

  * Really fix install files (LP: #1295069)

 -- Rohan Garg <rohangarg@kubuntu.org>  Thu, 20 Mar 2014 15:38:12 +0100

tomahawk (0.7.0+dfsg1-0ubuntu3) trusty; urgency=medium

  * Add kubuntu_fix-plugin-install.patch to fix plugin path installation
    (LP: #1287163)
  * Fix install files to not install headers

 -- Rohan Garg <rohangarg@kubuntu.org>  Wed, 05 Mar 2014 18:08:46 +0100

tomahawk (0.7.0+dfsg1-0ubuntu1) trusty; urgency=medium

  [ Aaron Honeycutt ]
  * New upstream release (LP: #1162601)
  * Repack upstream tarball so it's DFSG compliant

  [ Rohan Garg ]
  * Update copyright file a bit

 -- Rohan Garg <rohangarg@kubuntu.org>  Mon, 10 Feb 2014 20:09:50 +0100

tomahawk (0.6.0+dfsg1-0ubuntu3) saucy; urgency=low

  * Rebuild for libechonest2.1.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 17 Jul 2013 00:43:49 +0100

tomahawk (0.6.0+dfsg1-0ubuntu2) raring; urgency=low

  * Build with jreen and qtweetlib

 -- Harald Sitter <apachelogger@ubuntu.com>  Fri, 15 Mar 2013 13:51:06 +0100
